Index: python/FlexpartTools.py
===================================================================
--- python/FlexpartTools.py	(revision 9e660c47faa9ca2b9e19d5da43ad0027c730a960)
+++ python/FlexpartTools.py	(revision d69b6776d6d39e0af0d38c95cbfd78284c9866e4)
@@ -795,414 +615,363 @@
 
     def __init__(self,c,fluxes=False):
-        # different mars types for retrieving reanalysis data for flexpart
-
-        # set a counter for the number of mars requests generated
-        self.mreq_count = 0
-        self.types=dict()
-        try:
-            if c.maxstep>24: #len(c.type):    # Pure forecast mode
-                c.type=[c.type[0]] # AP changed this index from 1 to 0
-                c.step=['{:0>3}'.format(int(c.step[0]))]
-                c.time=[c.time[0]]
-                for i in range(1,c.maxstep+1):
-                    c.type.append(c.type[0])
-                    c.step.append('{:0>3}'.format(i))
-                    c.time.append(c.time[0])
-        except:
-            pass
-
-        self.inputdir=c.inputdir
-        self.basetime=c.basetime
-        self.dtime=c.dtime
-        self.mars={}
-        i=0
-        j=0
-        if fluxes==True and c.maxstep<=24:
-            self.types[str(c.acctype)]={'times':str(c.acctime),
-                                        'steps':'{}/to/{}/by/{}'.format(
-                                               c.dtime,c.accmaxstep,c.dtime)}
-            i=1
-            for k in [0,12]:
-                for j in range(int(c.dtime),13,int(c.dtime)):
-                    self.mars['{:0>3}'.format(i*int(c.dtime))]=[c.type[1],'{:0>2}'.format(k),'{:0>3}'.format(j)]
-                    i+=1
-        else:
-            for ty,st,ti in zip(c.type,c.step,c.time):
-                btlist=range(len(c.time))
-                if c.basetime=='12':
-                    btlist=[1,2,3,4,5,6,7,8,9,10,11,12]
-                if c.basetime=='00':
-                    btlist=[13,14,15,16,17,18,19,20,21,22,23,0]
-
-
-                if ((ty.upper() == 'AN' and mod(int(c.time[i]),int(c.dtime))==0 and int(c.step[i])==0) or \
-                   (ty.upper() != 'AN' and mod(int(c.step[i]),int(c.dtime))==0 and \
-                    mod(int(c.step[i]),int(c.dtime))==0) ) and \
-                   (i in btlist or c.maxstep>24):
-                    if ty not in self.types.keys():
-                        self.types[ty]={'times':'','steps':''}
-                    if ti not in self.types[ty]['times']:
-                        if len(self.types[ty]['times'])>0:
-                            self.types[ty]['times']+='/'
-                        self.types[ty]['times']+=ti
-                    if st not in self.types[ty]['steps']:
-                        if len(self.types[ty]['steps'])>0:
-                            self.types[ty]['steps']+='/'
-                        self.types[ty]['steps']+=st
-
-                    self.mars['{:0>3}'.format(j)]=[ty,'{:0>2}'.format(int(ti)),'{:0>3}'.format(int(st))]
-                    j+=int(c.dtime)
-
-                i+=1
-
-# Different grids need different retrievals
+# different mars types for retrieving reanalysis data for flexpart
+	
+	self.types=dict()
+	try:
+	    if c.maxstep>len(c.type):    # Pure forecast mode
+		c.type=[c.type[1]]
+		c.step=['{:0>3}'.format(int(c.step[0]))]
+		c.time=[c.time[0]]
+		for i in range(1,c.maxstep+1):
+		    c.type.append(c.type[0])
+		    c.step.append('{:0>3}'.format(i))
+		    c.time.append(c.time[0])
+	except:
+	    pass
+	
+	self.inputdir=c.inputdir
+	self.basetime=c.basetime
+	self.dtime=c.dtime
+	self.mars={}			    
+	i=0
+	j=0
+	if fluxes==True and c.maxstep<24:
+	    self.types[c.type[1]]={'times':'00/12','steps':'{}/to/12/by/{}'.format(c.dtime,c.dtime)}
+	    i=1
+	    for k in [0,12]:
+		for j in range(int(c.dtime),13,int(c.dtime)):
+		    self.mars['{:0>3}'.format(i*int(c.dtime))]=[c.type[1],'{:0>2}'.format(k),'{:0>3}'.format(j)]
+		    i+=1
+	else:
+	    for ty,st,ti in zip(c.type,c.step,c.time):
+		btlist=range(24)
+		if c.basetime=='12':
+		    btlist=[1,2,3,4,5,6,7,8,9,10,11,12]
+#		    btday =[0,0,0,0,0,0,0,0,0, 0, 0, 0]
+		if c.basetime=='00':
+		    btlist=[13,14,15,16,17,18,19,20,21,22,23,0]
+#		    btday =[-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1]
+#		    if c.step[0]=='00':
+#			btday[-1]=0
+		
+		if mod(i,int(c.dtime))==0 and (i in btlist or c.maxstep>24):
+		    if ty not in self.types.keys():
+			self.types[ty]={'times':'','steps':''}
+		    if ti not in self.types[ty]['times']:
+			if len(self.types[ty]['times'])>0:
+			    self.types[ty]['times']+='/'
+			self.types[ty]['times']+=ti
+		    if st not in self.types[ty]['steps']:
+			if len(self.types[ty]['steps'])>0:
+			    self.types[ty]['steps']+='/'
+			self.types[ty]['steps']+=st
+		    
+		    self.mars['{:0>3}'.format(j)]=[ty,'{:0>2}'.format(int(ti)),'{:0>3}'.format(int(st))]
+		    j+=int(c.dtime)
+		
+		i+=1
+		
+# Different grids need different retrievals	
 # SH=Spherical Harmonics, GG=Gaussian Grid, OG=Output Grid, ML=MultiLevel, SL=SingleLevel
-        self.params={'SH__ML':'','SH__SL':'',
+	self.params={'SH__ML':'','SH__SL':'',
                      'GG__ML':'','GG__SL':'',
                      'OG__ML':'','OG__SL':'',
-                     'OG_OROLSM_SL':'','OG_acc_SL':''}
-
-        self.marsclass=c.marsclass
-        self.stream=c.stream
-        self.number=c.number
-        self.resol=c.resol
-        if 'N' in c.grid:  # Gaussian output grid
-            self.grid=c.grid
-            self.area='G'
-        else:
-            self.grid='{}/{}'.format(int(c.grid)/1000.,int(c.grid)/1000.)
-            self.area='{}/{}/{}/{}'.format(int(c.upper)/1000.,int(c.left)/1000.,int(c.lower)/1000.,int(c.right)/1000.)
-
-        self.accuracy=c.accuracy
-        self.level=c.level
-        try:
-            self.levelist=c.levelist
-        except:
-            self.levelist='1/to/'+c.level
-        self.glevelist='1/to/'+c.level
-        try:
-            self.gaussian=c.gaussian
-        except:
-            self.gaussian=''
-        try:
-            self.dataset=c.dataset
-        except:
-            self.dataset=''
-        try:
-            self.expver=c.expver
-        except:
-            self.expver='1'
-        try:
-            self.number=c.number
-        except:
-            self.number='0'
-
-        self.outputfilelist=[]
-
-
+	             'OG_OROLSM_SL':'','OG_acc_SL':''}
+	
+	self.marsclass=c.marsclass
+	self.stream=c.stream
+	self.number=c.number
+	self.resol=c.resol
+	if 'N' in c.grid:  # Gaussian output grid
+	    self.grid=c.grid
+	    self.area='G'
+	else:
+	    self.grid='{}/{}'.format(int(c.grid)/1000.,int(c.grid)/1000.)
+	    self.area='{}/{}/{}/{}'.format(int(c.upper)/1000.,int(c.left)/1000.,int(c.lower)/1000.,int(c.right)/1000.)
+
+	self.accuracy=c.accuracy
+	self.level=c.level
+	try:
+	    self.levelist=c.levelist
+	except:
+	    self.levelist='1/to/'+c.level
+	self.glevelist='1/to/'+c.level
+	try:
+	    self.gaussian=c.gaussian
+	except:
+	    self.gaussian=''
+	try:
+	    self.dataset=c.dataset
+	except:
+	    self.dataset=''
+	try:
+	    self.expver=c.expver
+	except:
+	    self.expver='1'
+	try:
+	    self.number=c.number
+	except:
+	    self.number='0'
+	
+	self.outputfilelist=[]
+	    
+	
 # Now comes the nasty part that deals with the different scenarios we have:
-# 1) Calculation of etadot on
+# 1) Calculation of etadot on 
 #    a) Gaussian grid
 #    b) Output grid
 #    c) Output grid using parameter 77 retrieved from MARS
-# 3) Calculation/Retrieval of omega
+# 3) Calculation/Retrieval of omega 
 # 4) Download also data for WRF
 
         if fluxes==False:
-            self.params['SH__SL']=['LNSP','ML','1','OFF']
+	    self.params['SH__SL']=['LNSP','ML','1','OFF']
 #	    self.params['OG__SL']=["SD/MSL/TCC/10U/10V/2T/2D/129/172",'SFC','1',self.grid]
-            self.params['OG__SL']=["141/151/164/165/166/167/168/129/172",'SFC','1',self.grid]
-            if c.marsclass.upper() == 'EA' or c.marsclass.upper() == 'EP':
-                self.params['OG_OROLSM__SL']=["160/27/28/244",'SFC','1',self.grid]
-            else:
-                self.params['OG_OROLSM__SL']=["160/27/28/173",'SFC','1',self.grid]
-
-            if len(c.addpar)>0:
-                if c.addpar[0]=='/':
-                    c.addpar=c.addpar[1:]
-                self.params['OG__SL'][0]+='/'+'/'.join(c.addpar)
-            self.params['OG__ML']=['T/Q','ML',self.levelist,self.grid]
-
-            if c.gauss=='0' and c.eta=='1': # the simplest case
-                self.params['OG__ML'][0]+='/U/V/77'
-            elif c.gauss=='0' and c.eta=='0': # this is not recommended (inaccurate)
-                self.params['OG__ML'][0]+='/U/V'
-            elif c.gauss=='1' and c.eta=='0': # this is needed for data before 2008, or for reanalysis data
-                self.params['GG__SL']=['Q','ML','1','{}'.format((int(self.resol)+1)/2)]
-                self.params['SH__ML']=['U/V/D','ML',self.glevelist,'OFF']
-            else:
-                print 'Warning: This is a very costly parameter combination, use only for debugging!'
-                self.params['GG__SL']=['Q','ML','1','{}'.format((int(self.resol)+1)/2)]
-                self.params['GG__ML']=['U/V/D/77','ML',self.glevelist,'{}'.format((int(self.resol)+1)/2)]
-
-            if c.omega=='1':
-                self.params['OG__ML'][0]+='/W'
-
-            try:            # add cloud water content if necessary
-                if c.cwc=='1':
-                    self.params['OG__ML'][0]+='/CLWC/CIWC'
-            except:
-                pass
-
-            try:            # add vorticity and geopotential height for WRF if necessary
-                if c.wrf=='1':
-                    self.params['OG__ML'][0]+='/Z/VO'
-                    if '/D' not in self.params['OG__ML'][0]:
-                        self.params['OG__ML'][0]+='/D'
+	    self.params['OG__SL']=["141/151/164/165/166/167/168/129/172",'SFC','1',self.grid]
+	    self.params['OG_OROLSM__SL']=["160/27/28/173",'SFC','1',self.grid]
+	    
+	    if len(c.addpar)>0:
+	        if c.addpar[0]=='/':
+		    c.addpar=c.addpar[1:]
+		self.params['OG__SL'][0]+='/'+'/'.join(c.addpar)
+	    self.params['OG__ML']=['T/Q','ML',self.levelist,self.grid]
+	    
+	    if c.gauss=='0' and c.eta=='1': # the simplest case
+		self.params['OG__ML'][0]+='/U/V/77'
+	    elif c.gauss=='0' and c.eta=='0': # this is not recommended (inaccurate)
+		self.params['OG__ML'][0]+='/U/V'
+	    elif c.gauss=='1' and c.eta=='0': # this is needed for data before 2008, or for reanalysis data
+		self.params['GG__SL']=['Q','ML','1','{}'.format((int(self.resol)+1)/2)]
+		self.params['SH__ML']=['U/V/D','ML',self.glevelist,'OFF']
+	    else:
+		print 'Warning: This is a very costly parameter combination, use only for debugging!'
+		self.params['GG__SL']=['Q','ML','1','{}'.format((int(self.resol)+1)/2)]
+		self.params['GG__ML']=['U/V/D/77','ML',self.glevelist,'{}'.format((int(self.resol)+1)/2)]
+		
+	    if c.omega=='1':
+		self.params['OG__ML'][0]+='/W'
+		
+	    try:            # add cloud water content if necessary
+		if c.cwc=='1':
+		    self.params['OG__ML'][0]+='/CLWC/CIWC'
+	    except:
+		pass
+	    
+	    try:            # add vorticity and geopotential height for WRF if necessary
+		if c.wrf=='1':
+		    self.params['OG__ML'][0]+='/Z/VO'
+		    if '/D' not in self.params['OG__ML'][0]:
+			self.params['OG__ML'][0]+='/D'
 #		    wrf_sfc='sp/msl/skt/2t/10u/10v/2d/z/lsm/sst/ci/sd/stl1/stl2/stl3/stl4/swvl1/swvl2/swvl3/swvl4'.upper()
 #                            134/151/235/167/165/166/168/129/172/034/031/141/139/170/183/236/039/040/041/042
-                    wrf_sfc='134/235/167/165/166/168/129/172/34/31/141/139/170/183/236/39/40/41/42'.upper()
-                    lwrt_sfc=wrf_sfc.split('/')
-                    for par in lwrt_sfc:
-                        if par not in self.params['OG__SL'][0]:
-                            self.params['OG__SL'][0]+='/'+par
-
-            except:
-                pass
-        else:
-            self.params['OG_acc_SL']=["LSP/CP/SSHF/EWSS/NSSS/SSR",'SFC','1',self.grid]
-
-
-        return
-        # add additional WRF specific parameters here
-
+		    wrf_sfc='134/235/167/165/166/168/129/172/34/31/141/139/170/183/236/39/40/41/42'.upper()
+		    lwrt_sfc=wrf_sfc.split('/')
+		    for par in lwrt_sfc:
+			if par not in self.params['OG__SL'][0]:
+			    self.params['OG__SL'][0]+='/'+par 
+		    
+	    except:
+		pass
+	else:
+	    self.params['OG_acc_SL']=["LSP/CP/SSHF/EWSS/NSSS/SSR",'SFC','1',self.grid]
+		
+		
+	return
+	# add additional WRF specific parameters here
+		
     def create_namelist(self,c,filename):
-
+	
 #	if inputdir=="":
 #	    self.inputdir='.'
 #	else:
 #	    self.inputdir=inputdir
-
-        self.inputdir=c.inputdir
-        area=asarray(self.area.split('/')).astype(float)
-        grid=asarray(self.grid.split('/')).astype(float)
-
+	
+	self.inputdir=c.inputdir
+	area=asarray(self.area.split('/')).astype(float)
+	grid=asarray(self.grid.split('/')).astype(float)
+	
 #	if area[3]<0:
 #	    area[3]+=360
-        if area[1]>area[3]:
-            area[1]-=360
-        zyk=abs((area[3]-area[1]-360.)+grid[1])<1.e-6
-        maxl=int((area[3]-area[1])/grid[1])+1
-        maxb=int((area[0]-area[2])/grid[0])+1
-
-        f=open(self.inputdir+'/'+filename,'w')
-        f.write('&NAMGEN\n')
-        f.write(',\n  '.join(['maxl='+str(maxl),'maxb='+str(maxb),
-                              'mlevel='+self.level,'mlevelist='+'"'+self.levelist+'"',
-                    'mnauf='+self.resol,'metapar='+'77',
-                    'rlo0='+str(area[1]),'rlo1='+str(area[3]),'rla0='+str(area[2]),'rla1='+str(area[0]),
-                    'momega='+c.omega,'momegadiff='+c.omegadiff,'mgauss='+c.gauss,
-                    'msmooth='+c.smooth,'meta='+c.eta,'metadiff='+c.etadiff,'mdpdeta='+c.dpdeta]))
-
-        f.write('\n/\n')
-        f.close()
-        return
-
-
-    def retrieve(self, server, public, dates, request, times, inputdir=''):
+	if area[1]>area[3]:
+	    area[1]-=360
+	zyk=abs((area[3]-area[1]-360.)+grid[1])<1.e-6
+	maxl=int((area[3]-area[1])/grid[1])+1
+	maxb=int((area[0]-area[2])/grid[0])+1
+
+	f=open(self.inputdir+'/'+filename,'w')
+	f.write('&NAMGEN\n')
+	f.write(',\n  '.join(['maxl='+str(maxl),'maxb='+str(maxb),
+	            'mlevel='+self.level,'mlevelist='+'"'+self.levelist+'"',
+	            'mnauf='+self.resol,'metapar='+'77',
+	            'rlo0='+str(area[1]),'rlo1='+str(area[3]),'rla0='+str(area[2]),'rla1='+str(area[0]),
+	            'momega='+c.omega,'momegadiff='+c.omegadiff,'mgauss='+c.gauss,
+	            'msmooth='+c.smooth,'meta='+c.eta,'metadiff='+c.etadiff,'mdpdeta='+c.dpdeta]))
+	
+	f.write('\n/\n')
+	f.close()
+	return
+	
+             
+    def retrieve(self, server, dates,times, inputdir=''):
         self.dates=dates
         self.server=server
-        self.public=public
-
-        if inputdir=="":
-            self.inputdir='.'
-        else:
-            self.inputdir=inputdir
-
-            # Retrieve Q not for using Q but as a template for a reduced gaussian grid one date and time is enough
+
+	if inputdir=="":
+	    self.inputdir='.'
+	else:
+	    self.inputdir=inputdir
+
+	  # Retrieve Q not for using Q but as a template for a reduced gaussian grid one date and time is enough
 # Take analysis at 00
-#        qdate=self.dates
-#        idx=qdate.find("/")
-#        if (idx >0):
-#            qdate=self.dates[:idx]
-
-        #QG= MARSretrieval(self.server, self.public, dataset=self.dataset, marsclass=self.marsclass, stream=self.stream, type="an", levtype="ML", levelist="1",
-                            #gaussian="reduced",grid='{}'.format((int(self.resol)+1)/2), resol=self.resol,accuracy=self.accuracy,target=self.inputdir+"/"+"QG.grb",
-                            #date=qdate, time="00",expver=self.expver, param="133.128")
+        qdate=self.dates
+        idx=qdate.find("/")
+        if (idx >0):
+          qdate=self.dates[:idx]
+        
+        #QG= MARSretrieval(self.server, dataset=self.dataset, marsclass=self.marsclass, stream=self.stream, type="an", levtype="ML", levelist="1",
+                         #gaussian="reduced",grid='{}'.format((int(self.resol)+1)/2), resol=self.resol,accuracy=self.accuracy,target=self.inputdir+"/"+"QG.grb",
+                         #date=qdate, time="00",expver=self.expver, param="133.128")
         #QG.displayInfo()
         #QG.dataRetrieve()
 
-        oro=False
+	oro=False
         for ftype in self.types:
-            for pk,pv in self.params.iteritems():
-                if isinstance(pv,str):     # or pk!='GG__SL' :
-                    continue
-                mftype=''+ftype
-                mftime=self.types[ftype]['times']
-                mfstep=self.types[ftype]['steps']
-                mfdate=self.dates
-                mfstream=self.stream
-                mftarget=self.inputdir+"/"+ftype+pk+'.'+self.dates.split('/')[0]+'.'+str(os.getppid())+'.'+str(os.getpid())+".grb"
-
-                if pk=='OG__SL':
-                    pass
-                if pk=='OG_OROLSM__SL':
-                    if oro==False:
-                        # in CERA20C there is no stream "OPER"!
-                        if self.marsclass.upper() != 'EP':
-                            mfstream='OPER'
-                        mftype='AN'
-                        mftime='00'
-                        mfstep='000'
-                        mfdate=self.dates.split('/')[0]
-                        mftarget=self.inputdir+"/"+pk+'.'+mfdate+'.'+str(os.getppid())+'.'+str(os.getpid())+".grb"
-                        oro=True
-                    else:
-                        continue
-
-                if pk=='GG__SL' and pv[0]=='Q':
-                    area=""
-                    gaussian='reduced'
-                else:
-                    area=self.area
-                    gaussian=self.gaussian
-
-                if self.basetime==None:
-                    # increase number of mars requests
-                    self.mreq_count += 1
-                    MR= MARSretrieval(self.server, self.public, dataset=self.dataset, marsclass=self.marsclass, stream=mfstream,
-                                      type=mftype, levtype=pv[1], levelist=pv[2],resol=self.resol, gaussian=gaussian,
-                                  accuracy=self.accuracy,grid=pv[3],target=mftarget,area=area,
-                                  date=mfdate, time=mftime,number=self.number,step=mfstep, expver=self.expver, param=pv[0])
-
-                    if request == 0:
-                        MR.displayInfo()
-                        MR.dataRetrieve()
-                    elif request == 1:
-                        MR.print_infodata_csv(self.inputdir, self.mreq_count)
-                    elif request == 2:
-                        MR.print_infodata_csv(self.inputdir, self.mreq_count)
-                        MR.displayInfo()
-                        MR.dataRetrieve()
-# The whole else section is only necessary for operational scripts. It could be removed
-                else: # check if mars job requests fields beyond basetime. If yes eliminate those fields since they may not
-                        # be accessible with user's credentials
-                    sm1=-1
-                    if 'by' in mfstep:
-                        sm1=2
-                    tm1=-1
-                    if 'by' in mftime:
-                        tm1=2
-                    maxtime=datetime.datetime.strptime(mfdate.split('/')[-1]+mftime.split('/')[tm1],'%Y%m%d%H')+ \
-                        datetime.timedelta(hours=int(mfstep.split('/')[sm1]))
-
-                    elimit=datetime.datetime.strptime(mfdate.split('/')[-1]+self.basetime,'%Y%m%d%H')
-
-                    if self.basetime=='12':
-                        if 'acc' in pk:
-
-                    # Strategy: if maxtime-elimit>=24h reduce date by 1,
-                    # if 12h<=maxtime-elimit<12h reduce time for last date
-                    # if maxtime-elimit<12h reduce step for last time
-                    # A split of the MARS job into 2 is likely necessary.
-                            maxtime=elimit-datetime.timedelta(hours=24)
-                            mfdate='/'.join(('/'.join(mfdate.split('/')[:-1]),datetime.datetime.strftime(maxtime,'%Y%m%d')))
-                            # increase number of mars requests
-                            self.mreq_count += 1
-                            MR= MARSretrieval(self.server, self.public, dataset=self.dataset, marsclass=self.marsclass, stream=self.stream,
-                                              type=mftype, levtype=pv[1], levelist=pv[2],resol=self.resol, gaussian=gaussian,
-                                                accuracy=self.accuracy,grid=pv[3],target=mftarget,area=area,
-                                                date=mfdate, time=mftime,number=self.number,step=mfstep, expver=self.expver, param=pv[0])
-
-                            if request == 0:
-                                MR.displayInfo()
-                                MR.dataRetrieve()
-                            elif request == 1:
-                                MR.print_infodata_csv(self.inputdir, self.mreq_count)
-                            elif request == 2:
-                                MR.print_infodata_csv(self.inputdir, self.mreq_count)
-                                MR.displayInfo()
-                                MR.dataRetrieve()
-
-                            maxtime=elimit-datetime.timedelta(hours=12)
-                            mfdate=datetime.datetime.strftime(maxtime,'%Y%m%d')
-                            mftime='00'
-                            mftarget=self.inputdir+"/"+ftype+pk+'.'+mfdate+'.'+str(os.getppid())+'.'+str(os.getpid())+".grb"
-                            # increase number of mars requests
-                            self.mreq_count += 1
-                            MR= MARSretrieval(self.server, self.public, dataset=self.dataset, marsclass=self.marsclass, stream=self.stream,
-                                              type=mftype, levtype=pv[1], levelist=pv[2],resol=self.resol, gaussian=gaussian,
-                                                accuracy=self.accuracy,grid=pv[3],target=mftarget,area=area,
-                                                date=mfdate, time=mftime,number=self.number,step=mfstep, expver=self.expver, param=pv[0])
-                            if request == 0:
-                                MR.displayInfo()
-                                MR.dataRetrieve()
-                            elif request == 1:
-                                MR.print_infodata_csv(self.inputdir, self.mreq_count)
-                            elif request == 2:
-                                MR.print_infodata_csv(self.inputdir, self.mreq_count)
-                                MR.displayInfo()
-                                MR.dataRetrieve()
-                        else:
-                            # increase number of mars requests
-                            self.mreq_count += 1
-                            MR= MARSretrieval(self.server, self.public, dataset=self.dataset, marsclass=self.marsclass, stream=self.stream,
-                                              type=mftype, levtype=pv[1], levelist=pv[2],resol=self.resol, gaussian=gaussian,
-                                                accuracy=self.accuracy,grid=pv[3],target=mftarget,area=area,
-                                                date=mfdate, time=mftime,number=self.number,step=mfstep, expver=self.expver, param=pv[0])
-
-                            if request == 0:
-                                MR.displayInfo()
-                                MR.dataRetrieve()
-                            elif request == 1:
-                                MR.print_infodata_csv(self.inputdir, self.mreq_count)
-                            elif request == 2:
-                                MR.print_infodata_csv(self.inputdir, self.mreq_count)
-                                MR.displayInfo()
-                                MR.dataRetrieve()
-                    else:
-                        maxtime=elimit-datetime.timedelta(hours=24)
-                        mfdate=datetime.datetime.strftime(maxtime,'%Y%m%d')
-
-                        mftimesave=''.join(mftime)
-
-                        if pk=='OG_OROLSM__SL':
-                            mfdate=self.dates.split('/')[0]
-                            mftarget=self.inputdir+"/"+pk+'.'+mfdate+'.'+str(os.getppid())+'.'+str(os.getpid())+".grb"
-
-                        if '/' in mftime:
-                            times=mftime.split('/')
-                            while int(times[0])+int(mfstep.split('/')[0])<=12 and pk!='OG_OROLSM__SL' and 'acc' not in pk:
-                                times=times[1:]
-                                if len(times)>1:
-                                    mftime='/'.join(times)
-                                else:
-                                    mftime=times[0]
-
-                        if int(mftimesave.split('/')[0])==0 and int(mfstep.split('/')[0])==0 and pk!='OG_OROLSM__SL':
-                            mfdate=datetime.datetime.strftime(elimit,'%Y%m%d')
-                            mftime='00'
-                            mfstep='000'
-                            mftarget=self.inputdir+"/"+ftype+pk+'.'+mfdate+'.'+str(os.getppid())+'.'+str(os.getpid())+".grb"
-
-                        # increase number of mars requests
-                        self.mreq_count += 1
-                        MR= MARSretrieval(self.server, self.public, dataset=self.dataset, marsclass=self.marsclass, stream=self.stream,
-                                          type=mftype, levtype=pv[1], levelist=pv[2],resol=self.resol, gaussian=gaussian,
-                                      accuracy=self.accuracy,grid=pv[3],target=mftarget,area=area,
-                                      date=mfdate, time=mftime,number=self.number,step=mfstep, expver=self.expver, param=pv[0])
-
-                        if request == 0:
-                            MR.displayInfo()
-                            MR.dataRetrieve()
-                        elif request == 1:
-                            MR.print_infodata_csv(self.inputdir, self.mreq_count)
-                        elif request == 2:
-                            MR.print_infodata_csv(self.inputdir, self.mreq_count)
-                            MR.displayInfo()
-                            MR.dataRetrieve()
-
-
-        if request == 0 or request == 2:
-            print('MARS retrieve done ... ')
-        elif request == 1:
-            print('MARS request printed ...')
-
+	    for pk,pv in self.params.iteritems():
+		if isinstance(pv,str):     # or pk!='GG__SL' :
+		    continue
+		mftype=''+ftype
+		mftime=self.types[ftype]['times']
+		mfstep=self.types[ftype]['steps']
+		mfdate=self.dates
+		mfstream=self.stream
+		mftarget=self.inputdir+"/"+ftype+pk+'.'+self.dates.split('/')[0]+'.'+str(os.getppid())+'.'+str(os.getpid())+".grb"
+		if pk=='OG__SL':
+		    pass
+		if pk=='OG_OROLSM__SL':
+		    if oro==False:
+			mfstream='OPER'
+			mftype='AN'
+			mftime='00'
+			mfstep='000'
+			mfdate=self.dates.split('/')[0]
+			mftarget=self.inputdir+"/"+pk+'.'+mfdate+'.'+str(os.getppid())+'.'+str(os.getpid())+".grb"
+			oro=True
+		    else:
+			continue
+		
+	        if pk=='GG__SL' and pv[0]=='Q':
+		    area=""
+		    gaussian='reduced'
+		else:
+		    area=self.area
+		    gaussian=self.gaussian
+
+		if self.basetime==None:
+		    MR= MARSretrieval(self.server, dataset=self.dataset, marsclass=self.marsclass, stream=mfstream, 
+		                  type=mftype, levtype=pv[1], levelist=pv[2],resol=self.resol, gaussian=gaussian,
+		                  accuracy=self.accuracy,grid=pv[3],target=mftarget,area=area, 
+		                  date=mfdate, time=mftime,number=self.number,step=mfstep, expver=self.expver, param=pv[0])
+		
+		    MR.displayInfo()
+		    MR.dataRetrieve()
+# The whole else section is only necessary for operational scripts. It could be removed 
+		else: # check if mars job requests fields beyond basetime. If yes eliminate those fields since they may not
+		      # be accessible with user's credentials
+		    sm1=-1
+		    if 'by' in mfstep:
+			sm1=2
+		    tm1=-1
+		    if 'by' in mftime:
+			tm1=2
+		    maxtime=datetime.datetime.strptime(mfdate.split('/')[-1]+mftime.split('/')[tm1],'%Y%m%d%H')+ \
+		    datetime.timedelta(hours=int(mfstep.split('/')[sm1]))
+		    
+		    elimit=datetime.datetime.strptime(mfdate.split('/')[-1]+self.basetime,'%Y%m%d%H')
+
+		    if self.basetime=='12':
+			if 'acc' in pk:
+
+		    # Strategy: if maxtime-elimit>=24h reduce date by 1, 
+		    # if 12h<=maxtime-elimit<12h reduce time for last date
+		    # if maxtime-elimit<12h reduce step for last time
+		    # A split of the MARS job into 2 is likely necessary.
+			    maxtime=elimit-datetime.timedelta(hours=24)
+			    mfdate='/'.join(('/'.join(mfdate.split('/')[:-1]),datetime.datetime.strftime(maxtime,'%Y%m%d')))
+		    
+			    MR= MARSretrieval(self.server, dataset=self.dataset, marsclass=self.marsclass, stream=self.stream, 
+			                        type=mftype, levtype=pv[1], levelist=pv[2],resol=self.resol, gaussian=gaussian,
+			                        accuracy=self.accuracy,grid=pv[3],target=mftarget,area=area, 
+			                        date=mfdate, time=mftime,number=self.number,step=mfstep, expver=self.expver, param=pv[0])
+		
+			    MR.displayInfo()
+			    MR.dataRetrieve()
+		    
+			    maxtime=elimit-datetime.timedelta(hours=12)
+			    mfdate=datetime.datetime.strftime(maxtime,'%Y%m%d')
+			    mftime='00'
+			    mftarget=self.inputdir+"/"+ftype+pk+'.'+mfdate+'.'+str(os.getppid())+'.'+str(os.getpid())+".grb"
+
+			    MR= MARSretrieval(self.server, dataset=self.dataset, marsclass=self.marsclass, stream=self.stream, 
+			                        type=mftype, levtype=pv[1], levelist=pv[2],resol=self.resol, gaussian=gaussian,
+			                        accuracy=self.accuracy,grid=pv[3],target=mftarget,area=area, 
+			                        date=mfdate, time=mftime,number=self.number,step=mfstep, expver=self.expver, param=pv[0])
+		
+			    MR.displayInfo()
+			    MR.dataRetrieve()
+			else:
+			    MR= MARSretrieval(self.server, dataset=self.dataset, marsclass=self.marsclass, stream=self.stream, 
+			                        type=mftype, levtype=pv[1], levelist=pv[2],resol=self.resol, gaussian=gaussian,
+			                        accuracy=self.accuracy,grid=pv[3],target=mftarget,area=area, 
+			                        date=mfdate, time=mftime,number=self.number,step=mfstep, expver=self.expver, param=pv[0])
+		
+			    MR.displayInfo()
+			    MR.dataRetrieve()
+		    else:
+			maxtime=elimit-datetime.timedelta(hours=24)
+			mfdate=datetime.datetime.strftime(maxtime,'%Y%m%d')
+			
+			mftimesave=''.join(mftime)
+			
+			if '/' in mftime:
+			    times=mftime.split('/')
+			    while int(times[0])+int(mfstep.split('/')[0])<=12 and pk!='OG_OROLSM__SL' and 'acc' not in pk:
+				times=times[1:]
+				if len(times)>1:
+				    mftime='/'.join(times)
+				else:
+				    mftime=times[0]
+			    
+			MR= MARSretrieval(self.server, dataset=self.dataset, marsclass=self.marsclass, stream=self.stream, 
+		                      type=mftype, levtype=pv[1], levelist=pv[2],resol=self.resol, gaussian=gaussian,
+		                      accuracy=self.accuracy,grid=pv[3],target=mftarget,area=area, 
+		                      date=mfdate, time=mftime,number=self.number,step=mfstep, expver=self.expver, param=pv[0])
+		    
+			MR.displayInfo()
+			MR.dataRetrieve()
+			
+			if int(mftimesave.split('/')[0])==0 and int(mfstep.split('/')[0])==0 and pk!='OG_OROLSM__SL':
+			    mfdate=datetime.datetime.strftime(elimit,'%Y%m%d')
+			    mftime='00'
+			    mfstep='000'
+			    mftarget=self.inputdir+"/"+ftype+pk+'.'+mfdate+'.'+str(os.getppid())+'.'+str(os.getpid())+".grb"
+		    
+			    MR= MARSretrieval(self.server, dataset=self.dataset, marsclass=self.marsclass, stream=self.stream, 
+			                  type=mftype, levtype=pv[1], levelist=pv[2],resol=self.resol, gaussian=gaussian,
+			                  accuracy=self.accuracy,grid=pv[3],target=mftarget,area=area, 
+			                  date=mfdate, time=mftime,number=self.number,step=mfstep, expver=self.expver, param=pv[0])
+			
+			    MR.displayInfo()
+			    MR.dataRetrieve()
+							
+		    
+		    
+        print "MARS retrieve done... "
+        
     def getFlexpartTime(self, type,step, time):
-        cstep='{:0>3}'.format(step)
-        ctime='{:0>2}'.format(int(time/100))
+	cstep='{:0>3}'.format(step)
+	ctime='{:0>2}'.format(int(time/100))
 
         ctype = str(type).upper()
-        myinfo = [ctype,ctime, cstep]
+	myinfo = [ctype,ctime, cstep]
         cflextime = None
         for t, marsinfo in self.mars.items():
